/**  FinSearch
 *     Una finestrella tramite cui inserire i dati con cui fare la ricerca.
 *     I dati sono preimpostati per i campi dove  necessaria la scelta da 
 *		 una lista prefissata.
 *     @author     Emiliano Zappacosta
 *     @version    1.0
 *     @language   jdk 1.2.2
 */

package SOMA.gui;

import SOMA.gui.lingua.Lingua;
import SOMA.gui.*;
import SOMA.gui.FinSearchListener;
import SOMA.naming.PlaceID;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Hashtable;
import java.util.Vector;


public class FinSearch extends Finestra {

  // Variabili d'istanza:
      /**
       *  Riferimenti dati tramite il costruttore.
       */ 
  protected FinSearchListener mioAgente;
  protected ActionPlace actionPlace;

      /**
       *  Oggetti che mostrano frasi, coi che dipendono dalla lingua.
       */ 
  //protected JRadioButton radioCombo, radioTesto;
  protected JLabel       labType, labTitle, labAuthor, labSubject, labLanguage, labSpiega;
  protected JComboBox    comType1, comType2, comType3, comLanguage;
  protected JTextField   txtTitle, txtAuthor, txtSubject;
  protected JButton      botOK, botKO;


      /**
       *  Costruisce e mostra la finestra di inserimento dati.
       */ 
  public FinSearch (FinSearchListener mioAgente, ActionPlace actionPlace) {
    super (80, 60);    // CHIAMO IL COSTRUTTORE DELLA SUPERCLASSE

    this.mioAgente = mioAgente;
    this.actionPlace     = actionPlace;
    if (mioAgente != null)
      mioAgente.disabilitaFinestra();

    costruisciFinestra();
  } //costruttore


//METODO CHE IMPOSTA LE PROPRIETA' DEL LAYOUT
private void buildConstraints(GridBagConstraints gbc,int gx,int gy,int gw,int gh,int wx,int wy){
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
		}

     
      /**
       *  Vedi in superclasse {@link SOMA.gui.Finestra} il metodo {@link SOMA.gui.Finestra#costruisciFinestra()}
       */
  public void costruisciFinestra () {
    InizioCostruisciFinestra ();       // PARTE INIZIALE DI COSTRUZIONE DELLA FINESTRA
		
		String[] type1 = {"", "original", "surrogate"};
		String[] type2 = {"", "natural", "cultural"};
		String[] type3 = {"", "text", "image", "sound", "dataset", "software", "interactive resource",
											"service", "collection", "physical object", "event", "party", "place"};
		
		String[] lang  = {"",
											"ABKHAZIAN       AB","AFAN (OROMO)    OM","AFAR            AA","AFRIKAANS       AF","ALBANIAN        SQ",
											"AMHARIC         AM","ARABIC          AR","ARMENIAN        HY","ASSAMESE        AS","AYMARA          AY",
											"AZERBAIJANI     AZ","BASHKIR         BA","BASQUE          EU","BENGALI;BANGLA  BN","BHUTANI         DZ",
											"BIHARI          BH","BISLAMA         BI","BRETON          BR","BULGARIAN       BG","BURMESE         MY",
											"BYELORUSSIAN    BE","CAMBODIAN       KM","CATALAN         CA","CHINESE         ZH","CORSICAN        CO",
											"CROATIAN        HR","CZECH           CS","DANISH          DA","DUTCH           NL","ENGLISH         EN",
											"ESPERANTO       EO","ESTONIAN        ET","FAROESE         FO","FIJI            FJ","FINNISH         FI",
											"FRENCH          FR","FRISIAN         FY","GALICIAN        GL","GEORGIAN        KA","GERMAN          DE",
											"GREEK           EL","GREENLANDIC     KL","GUARANI         GN","GUJARATI        GU","HAUSA           HA",
											"HEBREW          HE","HINDI           HI","HUNGARIAN       HU","ICELANDIC       IS","INDONESIAN      ID",
											"INTERLINGUA     IA","INTERLINGUE     IE","INUKTITUT       IU","INUPIAK         IK","IRISH           GA",
											"ITALIAN         IT","JAPANESE        JA","JAVANESE        JV","KANNADA         KN","KASHMIRI        KS",
											"KAZAKH          KK","KINYARWANDA     RW","KIRGHIZ         KY","KURUNDI         RN","KOREAN          KO",
											"KURDISH         KU","LAOTHIAN        LO","LATIN           LA","LATVIAN;LETTISH LV","LINGALA         LN",
											"LITHUANIAN      LT","MACEDONIAN      MK","MALAGASY        MG","MALAY           MS","MALAYALAM       ML",
											"MALTESE         MT","MAORI           MI","MARATHI         MR","MOLDAVIAN       MO","MONGOLIAN       MN",
											"NAURU           NA","NEPALI          NE","NORWEGIAN       NO","OCCITAN         OC","ORIYA           OR",
											"PASHTO;PUSHTO   PS","PERSIAN (farsi) FA","POLISH          PL","PORTUGUESE      PT","PUNJABI         PA",
											"QUECHUA         QU","RHAETO-ROMANCE  RM","ROMANIAN        RO","RUSSIAN         RU","SAMOAN          SM",
											"SANGHO          SG","SANSKRIT        SA","SCOTS GAELIC    GD","SERBIAN         SR","SERBO-CROATIAN  SH",
											"SESOTHO         ST","SETSWANA        TN","SHONA           SN","SINDHI          SD","SINGHALESE      SI",
											"SISWATI         SS","SLOVAK          SK","SLOVENIAN       SL","SOMALI          SO","SPANISH         ES",
											"SUNDANESE       SU","SWAHILI         SW","SWEDISH         SV","TAGALOG         TL","TAJIK           TG",
											"TAMIL           TA","TATAR           TT","TELUGU          TE","THAI            TH","TIBETAN         BO",
											"TIGRINYA        TI","TONGA           TO","TSONGA          TS","TURKISH         TR","TURKMEN         TK",
											"TWI             TW","UIGUR           UG","UKRAINIAN       UK","URDU            UR","UZBEK           UZ",
											"VIETNAMESE      VI","VOLAPUK         VO","WELSH           CY","WOLOF           WO","XHOSA           XH",
											"YIDDISH         YI","YORUBA          YO","ZHUANG          ZA","ZULU            ZU"};

    labSpiega   = new JLabel ();
    labType     = new JLabel ();
		labTitle		= new JLabel ();
		labAuthor		= new JLabel ();
		labSubject	= new JLabel ();
		labLanguage	= new JLabel ();

    txtTitle 		= new JTextField (30);
    txtAuthor		= new JTextField (30);
    txtSubject	= new JTextField (30);
 		txtTitle.setText("");
 		txtAuthor.setText("");
 		txtSubject.setText("");

		comType1 		= new JComboBox (type1);
		comType2		= new JComboBox (type2);
		comType3		= new JComboBox (type3);
		comLanguage	= new JComboBox (lang);

    botOK = new JButton ();
    botKO = new JButton ();

    impostaFrasi ();         // IMPOSTA LE FRASI (DIPENDENTI DALLA LINGUA)

    ListBottoni bottoniera = new ListBottoni();

    botOK.setCursor (cursoreBottone);
    botOK.setIcon (new ImageIcon(PICTURE_PATH+"Opensesa.gif"));
    botOK.addActionListener (bottoniera);
    botOK.setActionCommand("ok");
    botKO.setCursor (cursoreBottone);
    botKO.setIcon (new ImageIcon(PICTURE_PATH+"BotKO.gif"));
    botKO.addActionListener (bottoniera);
    botKO.setActionCommand("cancel");
    botKO.setPressedIcon(new ImageIcon(PICTURE_PATH+"Zampina.gif"));

    mioFrame.addWindowListener (bottoniera);

    GridBagLayout GBL = new GridBagLayout();
    GridBagConstraints CC = new GridBagConstraints();
    PanCentro.setLayout (GBL);

    // AGGIUNGO SPAZIO VUOTO ATTORNO AL PANNELLO
    PanCentro.setBorder (BorderFactory.createEmptyBorder(10, 15, 8, 15));   // alto,sx,basso,dx

    Component spazio;
    
    buildConstraints(CC,0,0,4,1,0,10);
   	CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (labSpiega, CC);
    PanCentro.add (labSpiega);

		spazio = Box.createRigidArea (new Dimension(5,15));
    buildConstraints(CC,0,1,4,1,0,10);
    CC.anchor = GridBagConstraints.CENTER;
    GBL.setConstraints (spazio, CC);
    PanCentro.add (spazio);

    buildConstraints(CC,0,2,1,1,0,10);
    CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (labType, CC);
    PanCentro.add (labType);
    
    buildConstraints(CC,1,2,1,1,0,10);
    //CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (comType1, CC);
    PanCentro.add (comType1);

    buildConstraints(CC,2,2,1,1,0,10);
    //CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (comType2, CC);
    PanCentro.add (comType2);

    buildConstraints(CC,3,2,1,1,0,10);
    //CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (comType3, CC);
    PanCentro.add (comType3);

    buildConstraints(CC,0,3,1,1,0,10);
		CC.anchor = GridBagConstraints.WEST;
		GBL.setConstraints (labTitle, CC);
    PanCentro.add (labTitle);

    buildConstraints(CC,1,3,3,1,0,10);
		GBL.setConstraints (txtTitle, CC);
    PanCentro.add (txtTitle);


    buildConstraints(CC,0,4,1,1,0,10);
    CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (labAuthor, CC);
    PanCentro.add (labAuthor);

    buildConstraints(CC,1,4,3,1,0,10);
    GBL.setConstraints (txtAuthor, CC);
    PanCentro.add (txtAuthor);

    buildConstraints(CC,0,5,1,1,0,10);
	  CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (labSubject, CC);
    PanCentro.add (labSubject);

    buildConstraints(CC,1,5,3,1,0,10);
		GBL.setConstraints (txtSubject, CC);
    PanCentro.add (txtSubject);

    buildConstraints(CC,0,6,1,1,0,10);
    CC.anchor = GridBagConstraints.WEST;
		GBL.setConstraints (labLanguage, CC);
    PanCentro.add (labLanguage);

    buildConstraints(CC,1,6,3,1,0,10);
    GBL.setConstraints (comLanguage, CC);
    PanCentro.add (comLanguage);

    spazio = Box.createRigidArea (new Dimension(5,15));
    buildConstraints(CC,0,7,4,1,0,10);
    CC.anchor = GridBagConstraints.CENTER;
    GBL.setConstraints (spazio, CC);
    PanCentro.add (spazio);
 
    buildConstraints(CC,0,8,2,1,0,0);
    CC.anchor = GridBagConstraints.WEST;
    GBL.setConstraints (botOK, CC);
    PanCentro.add (botOK);

    buildConstraints(CC,3,8,1,1,0,0);
    CC.anchor = GridBagConstraints.EAST;
    GBL.setConstraints (botKO, CC);
    PanCentro.add (botKO);


    FineCostruisciFinestra ();       // PARTE FINALE DI COSTRUZIONE DELLA FINESTRA
  } //costruisciFinestra

      /**
       *  Vedi in superclasse {@link SOMA.gui.Finestra} il metodo {@link SOMA.gui.Finestra#creaBarraMenu()}
       */
  protected void creaBarraMenu () {
    creaBarraMenuDefault (Finestra.MENU_CLOSE);
  } //creaBarraMenu

        /**
       *  Vedi in superclasse {@link SOMA.gui.Finestra} il metodo {@link SOMA.gui.Finestra#distruggiFinestra()}
       */
  public void distruggiFinestra () {
    //panPlace.distruggimi();

    super.distruggiFinestra();

    if (mioAgente != null) {
      mioAgente.abilitaFinestra();
      mioAgente.inPrimoPiano();
    }
  } //distruggiFinestra

      /**
       *  Vedi in superclasse {@link SOMA.gui.Finestra} il metodo {@link SOMA.gui.Finestra#impostaFrasi()}
       */
  protected void impostaFrasi () {
    mioFrame.setTitle (Lingua.frase("FSE_WINTITLE"));

    labSpiega.setText (Lingua.frase("FSE_SPIEGAZ"));

    labType.setText ("Type");
    labTitle.setText ("Title");
    labAuthor.setText ("Author");
    labSubject.setText ("Subject");
    labLanguage.setText ("Language");
    
    botOK.setText (Lingua.frase("FSE_BOT_PUT"));
    botKO.setText (Lingua.frase("FSE_BOT_CANC"));
		botOK.setToolTipText (Lingua.frase("FSE_TIP_OK"));
    botKO.setToolTipText (Lingua.frase("FSE_TIP_CANC"));

    FineImpostaFrasi();      // APPORTA ALLA FINESTRA LE MODIFICHE FATTE
  } //impostaFrasi


      /**
       *  CLASSE INTERNA PER ASCOLTARE LA PRESSIONE DEI BOTTONI DELLA FINESTRA.
       */
  class ListBottoni extends WindowAdapter implements ActionListener {

    public void actionPerformed (ActionEvent e) {
      String azione = e.getActionCommand();
      if (azione.equals("ok")) {

        // PRELEVA I DATI DAL PANNELLO:
 			 
			  Hashtable searchContent = new Hashtable();

 			 	Vector vcontent = new Vector();
        String campo = (String)comType1.getSelectedItem();
        if(! campo.equals("")) vcontent.add(campo);
        campo = (String)comType2.getSelectedItem();
        if(! campo.equals("")) vcontent.add(campo);
 				campo = (String)comType3.getSelectedItem();
        if(! campo.equals("")) vcontent.add(campo);
			  if (vcontent.size() >0) searchContent.put("<type>", vcontent);
				
				vcontent = new Vector();
				campo = txtTitle.getText();
        if(! campo.equals("")) {				
        	campo.toLowerCase();
        	vcontent.add(campo);
			  	searchContent.put("<title>", vcontent);}
			  
				vcontent = new Vector();
				int i=0;
				campo = txtAuthor.getText();
 				campo.toLowerCase();
				if( ! campo.equals("") ){ 
					for(int p=0; (p=campo.indexOf(',',i))>0; i=p+1)
 							vcontent.add( campo.substring(i, p) );
 					vcontent.add( campo.substring(i) );
  				searchContent.put("<creator>", vcontent);}

				vcontent = new Vector();
				i=0;
				campo = txtSubject.getText();
				campo.toLowerCase();
        if(! campo.equals("")) {
					for(int p=0; (p=campo.indexOf(',',i))>0; i=p+1)
 							vcontent.add( campo.substring(i, p) );
 					vcontent.add( campo.substring(i) );
			  	searchContent.put("<subject>", vcontent);}

				vcontent = new Vector();
				campo = (String)comLanguage.getSelectedItem();
			//	campo;
        if(! campo.equals("")) {
					vcontent.add(campo.substring(campo.length()-2).toLowerCase());
			 		searchContent.put("<language>", vcontent);}

        // ESEGUE L'AZIONE SULLA FINESTRA "mioAgente" PASSANDOLE I DATI:
        mioAgente.eseguiAzioneSearch (searchContent);

        // Se tutto ok, distruggo questa finestra
        distruggiFinestra();

      }
      else
        // Altrimenti, distruggo questa finestra!
        distruggiFinestra();
    } //actionPerformed

    public void windowClosing (WindowEvent e)   { 
      distruggiFinestra();   // distruggo questa finestra (torno a Inizio)
    } //windowClosing
  } //ListBottoni

} //FinGoto1000