//Title:       dcXML-Lexer
//Version:     1.0
//Copyright:   Copyright (c) 2001
//Author:      E.Zappacosta
//Company:    
//Description: dcXMLLexer che definisce un analizzatore lessicale per
//					   file di metadati Dublin Core codificati in XML; estende  
//						 la classe predefinita java StreamTokenizer 


/* ==========================================================================
	Lexer.java   definisce un analizzatore lessicale
  ============================================================================== */
import java.io.*;

class dcXMLLexer extends StreamTokenizer{

//********* Costruttori ******************************************	

public dcXMLLexer( Reader R ) throws Exception{
	super(R);
	Init(  );

  int n=nextToken();
  String T;
	if (n == '<') {
		T= readTag();
		if (! T.equals("<?xmlversion=1.0?>")) 
			throw new Exception("not XML file or not version 1.0");
		}
	else throw new Exception("not XML file or not version 1.0");
	}//dcXMLLexer
	

	
public void	Init(  )  {
//		parseNumbers();
		lowerCaseMode( true );
/*		ordinaryChar('.');
		//ordinaryChar('-');
		ordinaryChar('/');
		ordinaryChar(39);*/
//		wor0dChars('<','?');
		ordinaryChar('0');
		ordinaryChar('1');
		ordinaryChar('2');
		ordinaryChar('3');
		ordinaryChar('4');
		ordinaryChar('5');
		ordinaryChar('6');
		ordinaryChar('7');
		ordinaryChar('8');
		ordinaryChar('9');

		wordChars('-','-');
		wordChars('?','?');
		wordChars('=','=');
		wordChars('/','/');
		wordChars('0','9');
		wordChars(39,39);
		
		whitespaceChars(',',',');
		whitespaceChars(';',';');
	}


	
	
//********* Metodi vari ******************************************	

	
	public String next() throws Exception {
    String T; 
    
     int n=nextToken();
     switch (n) {
      case TT_WORD:
			  T = new String (sval);break;	  					// Tag o parola

           
      case TT_EOF: 
             T= "EOF";break;					// end of file
    
/*     	case '.':	T= new IdentSexp(".");break;				// dotToken

      case '(': T=new IdentSexp("("); break;				// lparToken
      case ')': T=new IdentSexp(")"); break;				// rparToken
 // Operatori 
	    case '-': T=new Operator("-"); break;	
	    case '+': T=new Operator("+"); break;				  
	    case '*': T=new Operator("*"); break;				  
	    case '/': T=new Operator("/"); break;				  
	    case '=': T=new Operator("="); break;				  
 // Specialform 
	    case 39 : T=new SpecialForm("'"); break;	// quote '*/
	    case '<': T= readTag(); break;

      default:  T = new String ();	 // punteggiatura

    	}//switch
    return T;
  }//next



private String readTag() throws Exception {
		String s = new String("<");
		for(int n=nextToken(); n!='>';	n=nextToken())
			s+=sval;
		s+=">";
		return s;
	}// readTag
		
	
}//SexpLexer